diff --git a/sound/pci/hda/patch_realtek.c b/sound/pci/hda/patch_realtek.c
index 4407f7da57c4..9a6fe6048b60 100644
--- a/sound/pci/hda/patch_realtek.c
+++ b/sound/pci/hda/patch_realtek.c
@@ -21,6 +21,7 @@
 #include <sound/core.h>
 #include <sound/jack.h>
 #include <sound/hda_codec.h>
+#include <sound/soc.h>
 #include "hda_local.h"
 #include "hda_auto_parser.h"
 #include "hda_jack.h"
@@ -74,6 +75,11 @@ struct alc_coef_led {
 	unsigned int off;
 };
 
+struct alc_soc_dai_node {
+	struct list_head node;
+	struct snd_soc_dai *dai;
+};
+
 struct alc_spec {
 	struct hda_gen_spec gen; /* must be at head */
 
@@ -126,6 +132,9 @@ struct alc_spec {
 	unsigned int coef0;
 	struct input_dev *kb_dev;
 	u8 alc_mute_keycode_map[1];
+
+	/* ASoC DAIs used to init ASoC components in this sound card */
+	struct list_head soc_dais;
 };
 
 /*
@@ -6443,6 +6452,96 @@ static void alc287_fixup_legion_15imhg05_speakers(struct hda_codec *codec,
 	}
 }
 
+static void alc_soc_dai_clear_list(struct alc_spec *spec)
+{
+	struct alc_soc_dai_node *n, *tmp;
+
+	if (list_empty(&spec->soc_dais))
+		return;
+
+	list_for_each_entry_safe(n, tmp, &spec->soc_dais, node) {
+		list_del(&n->node);
+		kfree(n);
+	}
+}
+
+static int alc_add_soc_dai_list(struct alc_spec *spec, const char *dai_name)
+{
+#if IS_ENABLED(CONFIG_SND_SOC)
+	struct snd_soc_dai_link_component dlc;
+	struct alc_soc_dai_node *dai_node;
+	//struct snd_soc_component *comp;
+	struct snd_soc_dai *dai;
+
+	dlc.dai_name = dai_name;
+	dlc.of_node = NULL;
+	dlc.name = NULL;
+
+	dai = snd_soc_find_dai(&dlc);
+	if (!dai)
+		return -EPROBE_DEFER;
+
+	dai_node = kmalloc(sizeof(*dai_node), GFP_KERNEL);
+	if (!dai_node)
+		return -ENOMEM;
+	dai_node->dai = dai;
+
+	list_add(&dai_node->node, &spec->soc_dais);
+
+	return 0;
+#else
+	return -EPERM;
+#endif
+}
+
+void lenovo_y760_pcm_playback_hook(struct hda_pcm_stream *hinfo, struct hda_codec *cdc,
+				   struct snd_pcm_substream *sub, int act)
+{
+	struct alc_spec *spec = cdc->spec;
+	struct alc_soc_dai_node *dai_node;
+	struct snd_soc_dai *dai;
+	unsigned int rx_slots[2] = {1, 0};
+	int i = 0;
+
+	list_for_each_entry(dai_node, &spec->soc_dais, node) {
+		dai = dai_node->dai;
+		if (!dai->driver->ops)
+			continue;
+		switch (act) {
+		case HDA_GEN_PCM_ACT_PREPARE:
+			if (dai->driver->ops->set_channel_map)
+				dai->driver->ops->set_channel_map(dai, 0, NULL, 1, &rx_slots[i++]);
+			if (dai->driver->ops->prepare)
+				dai->driver->ops->prepare(sub, dai);
+			break;
+		case HDA_GEN_PCM_ACT_CLOSE:
+			if (dai->driver->ops->shutdown)
+				dai->driver->ops->shutdown(sub, dai);
+			break;
+		}
+	}
+
+}
+
+static void alc287_fixup_lenovo_y760(struct hda_codec *codec, const struct hda_fixup *fix, int act)
+{
+	struct alc_spec *spec = codec->spec;
+	int ret;
+
+	INIT_LIST_HEAD(&spec->soc_dais);
+
+	ret = alc_add_soc_dai_list(spec, "i2c-CLSA0100:00-cs35l41.0");
+	if (ret)
+		return;
+
+	ret = alc_add_soc_dai_list(spec, "i2c-CLSA0100:00-cs35l41.1");
+	if (ret) {
+		alc_soc_dai_clear_list(spec);
+		return;
+	}
+	spec->gen.pcm_playback_hook = lenovo_y760_pcm_playback_hook;
+}
+
 /* for alc295_fixup_hp_top_speakers */
 #include "hp_x360_helper.c"
 
@@ -6663,7 +6762,8 @@ enum {
 	ALC287_FIXUP_LEGION_15IMHG05_SPEAKERS,
 	ALC287_FIXUP_LEGION_15IMHG05_AUTOMUTE,
 	ALC287_FIXUP_YOGA7_14ITL_SPEAKERS,
-	ALC287_FIXUP_13S_GEN2_SPEAKERS
+	ALC287_FIXUP_13S_GEN2_SPEAKERS,
+	ALC287_FIXUP_LENOVO_Y760
 };
 
 static const struct hda_fixup alc269_fixups[] = {
@@ -8361,6 +8461,10 @@ static const struct hda_fixup alc269_fixups[] = {
 		.chained = true,
 		.chain_id = ALC269_FIXUP_HEADSET_MODE,
 	},
+	[ALC287_FIXUP_LENOVO_Y760] = {
+		.type = HDA_FIXUP_FUNC,
+		.v.func = alc287_fixup_lenovo_y760,
+	},
 };
 
 static const struct snd_pci_quirk alc269_fixup_tbl[] = {
@@ -8755,6 +8859,7 @@ static const struct snd_pci_quirk alc269_fixup_tbl[] = {
 	SND_PCI_QUIRK(0x17aa, 0x3818, "Lenovo C940", ALC298_FIXUP_LENOVO_SPK_VOLUME),
 	SND_PCI_QUIRK(0x17aa, 0x3827, "Ideapad S740", ALC285_FIXUP_IDEAPAD_S740_COEF),
 	SND_PCI_QUIRK(0x17aa, 0x3843, "Yoga 9i", ALC287_FIXUP_IDEAPAD_BASS_SPK_AMP),
+	SND_PCI_QUIRK(0x17aa, 0x3847, "Legion Y760", ALC287_FIXUP_LENOVO_Y760),
 	SND_PCI_QUIRK(0x17aa, 0x3813, "Legion 7i 15IMHG05", ALC287_FIXUP_LEGION_15IMHG05_SPEAKERS),
 	SND_PCI_QUIRK(0x17aa, 0x3852, "Lenovo Yoga 7 14ITL5", ALC287_FIXUP_YOGA7_14ITL_SPEAKERS),
 	SND_PCI_QUIRK(0x17aa, 0x3853, "Lenovo Yoga 7 15ITL5", ALC287_FIXUP_YOGA7_14ITL_SPEAKERS),
@@ -9499,6 +9604,8 @@ static int patch_alc269(struct hda_codec *codec)
 	spec->shutup = alc_default_shutup;
 	spec->init_hook = alc_default_init;
 
+	INIT_LIST_HEAD(&spec->soc_dais);
+
 	switch (codec->core.vendor_id) {
 	case 0x10ec0269:
 		spec->codec_variant = ALC269_TYPE_ALC269VA;